/* 
 File:            Macros.h
 Specifica:       macro di vario tipo
 */

#ifndef Shell_Unix_Macros_h
#define Shell_Unix_Macros_h

#include <stdio.h>  /* serve per la perror */
#include <stdlib.h> /* serve per la exit   */
#include <string.h> /* serve per strlen    */
#include <errno.h>  /* serve per errno     */
#include <unistd.h> /* serve per la write  */

/* Macro parametriche */
#define IFERROR_TWO(s,m) if((s)==-1)     { puts(m); exit(EXIT_FAILURE); }
#define IFERROR_THREE(s,m,c) if((s)==-1) { puts(m); c; }
#define IFOPEN_DIR(s,m,c) if ((s)==NULL) { puts(m); c; }
#define WRITE(m) IFERROR_TWO(write(STDOUT,m,strlen(m)),m);
#define WRITELN(m) WRITE(m); WRITE("\n");

enum { STDIN,STDOUT,STDERR };

/* Lunghezza massima comando */
#define MAX_COMMAND_SIZE 256 
/* Lunghezza massima del percorso di un file */
#define MAX_PATH_SIZE    200
/* Lunghezza massima dei buffer */
#define MAX_BUFFER_SIZE  1024 
/* Stringa stampata a schermo se l'allocazione dinamica di memoria fallisce */
#define BAD_ALLOC "Bad allocation! malloc() failed to allocate memory! Exiting program..."

/* Esiti della visita ricorsiva di una directory */
enum { WALK_OK=1, WALK_NAMETOOLONG, WALK_OPEN_ERROR, WALK_ERROR, WALK_MKDIR_ERROR, WALK_REMOVE_FILE };


#endif