/*
 File:       main.c
 Specifica:  Unix Shell v. 1.1
 */

/* Librerie per chiamate sui file */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/* Librerie per chiamate sui processi */
#include <sys/types.h>  
#include <sys/wait.h>   

/* Librerie per le funzioni standard */
#include <stdio.h>

/* Headers */
#include "Utility_Function.h" 
#include "Macros.h" 
#include "Commands_Function.h"
#include "Interpretation_Commands.h"
#include "Utility_Function.h"

/* Ado ogni iterazione viene verificato se ci sono processi attivi in background,
   avviene la lettura del comando che verrà interpretato e alla fine la memoria occupata
   viene liberata 
*/


int main()
{
    char *commandBuffer, *pathBuffer;
    check_alloc(commandBuffer=(char *)malloc(MAX_COMMAND_SIZE));
    check_alloc(pathBuffer=(char *)malloc(MAX_PATH_SIZE));
    char **argv;
    unsigned int argc;
    while (1)
    {
        checkEndProcess();
        sprintf(commandBuffer,"\n%s : %s >> ",getenv("USER"),getcwd(pathBuffer,MAX_PATH_SIZE));
        writeAndCheck(STDOUT,&commandBuffer,strlen(commandBuffer));
        readAndCheck(STDIN,commandBuffer,MAX_COMMAND_SIZE);
        if (strcmp(commandBuffer,"exit")== 0) break;
        if (strcmp(commandBuffer,"")==0) continue; 
        argv=splitArgument(commandBuffer,";",&argc);
        interpretCommandSequence(argc,argv);
        freeArgument(argv);
    }
    free(commandBuffer);
    free(pathBuffer);
    return 0;
}